local ReadIdentifier
local ReadColour
local ReadVector3
local ReadTransform
local XYZtoRUF
local FindLocalTransform
local nodeByName

function ReadIdentifier fID = 
(
	val = ReadShort fID #unsigned
	str = ""
	for i1 = 1 to val do
	(
		str = str + (bit.IntAsChar (readByte fID))
	)
	ret = str
)

function ReadColour f = 
(
	colr = (point3 ((ReadFloat f)*255) ((ReadFloat f)*255) ((ReadFloat f)*255)) as color
)

function ReadVector3 f =
(
	vect = point3 (ReadFloat f) (ReadFloat f) (ReadFloat f)
)

function ReadTransform f =
(
	local ReadVector3
	function ReadVector3 f =
	(
	local ret
	ret = point3 (ReadFloat f) (ReadFloat f) (ReadFloat f)
	)
	M = matrix3 0
	M.row1 = (ReadVector3 f)
	M.row2 = (ReadVector3 f)
	M.row3 = (ReadVector3 f)
	M.row4 = (ReadVector3 f)
	ret = M
)

function XYZtoRUF T =
(
	-- Armada uses Right-Up-Front convention. Convert from XYZ to RUF
	-- This function swaps the y and z components of position and rotation matrices
	rc1 = T.row1
	rc2 = T.row2
	rc3 = T.row3
	pc = T.row4

	Truf = matrix3 1
	Truf.row1 = point3 rc1[1] rc1[3] rc1[2]
	Truf.row2 = point3 rc3[1] rc3[3] rc3[2]
	Truf.row3 = point3 rc2[1] rc2[3] rc2[2]
	Truf.row4 = point3 pc.x pc.z pc.y

	Tret = Truf
)

function FindLocalTransform Tc Tp norm_par just_pos = 
(
	if just_pos then -- force no rotation
	(
		-- Local position transform
		pp = Tp.row4
		pc = Tc.row4
		ppc = pc-pp
		Tpc = matrix3 1
		Tpc.row4 = ppc
		Tret = Tpc
	)
	else --rotation as well
	(
		-- Get the local rotation transform
		if norm_par then
		(
			-- Make transforms orthogonal in case that they are not.
			Tc = NormalizeTransform Tc
			Tp = NormalizeTransform Tp
		)
			-- Compute the relative transform (local transform)
			Tpc = Tc * inverse(Tp)
	)
) -- end FindLocalTransform

-- Find node by name
function nodeByName nameStr =
(
	foundObj = undefined
	for obj in $helpers do
	(
		if (obj.name == nameStr) then
		(
			foundObj = obj
			exit true
		)
		if (obj.name == ("s_" + nameStr)) then
		(
			foundObj = obj
			exit true
		)
		if (obj.name == ("e_" + nameStr)) then
		(
			foundObj = obj
			exit true
		)
	)
	if (foundObj == undefined) then
	(
		for obj in $geometry do
		(
			if (obj.name == nameStr) then
			(
				foundObj = obj
				exit true
			)
		)
	)	
	ret = foundObj
)